module WorkflowSequel
  def load_workflow_state
    send( self.class.workflow_column )
  end

  def persist_workflow_state(new_value)
    send( "#{self.class.workflow_column}=", new_value )
    save( changed: true, validate: false)
  end

  def dataset_update( attrs )
    @@whitelist ||= (self.columns - [:id]).freeze
    self.class.instance_dataset.where( id: id ).update( attrs.delete_if{|k,v| [:id, 'id'].include?(k) } )
  end

  def before_validation
    send( "#{self.class.workflow_column}=", current_state.to_s ) unless send( self.class.workflow_column )
    super
  end

end
